<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.16"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>Zonzay: dlib::multiclass_svm_problem&lt; matrix_type, sample_type, label_type &gt; Class Template Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="zonzay.png"/></td>
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">Zonzay
   &#160;<span id="projectnumber">1</span>
   </div>
   <div id="projectbrief">Laugh game challenge</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.16 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="namespacedlib.html">dlib</a></li><li class="navelem"><a class="el" href="classdlib_1_1multiclass__svm__problem.html">multiclass_svm_problem</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="summary">
<a href="#pub-types">Public Types</a> &#124;
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="#pri-methods">Private Member Functions</a> &#124;
<a href="#pri-attribs">Private Attributes</a> &#124;
<a href="classdlib_1_1multiclass__svm__problem-members.html">List of all members</a>  </div>
  <div class="headertitle">
<div class="title">dlib::multiclass_svm_problem&lt; matrix_type, sample_type, label_type &gt; Class Template Reference</div>  </div>
</div><!--header-->
<div class="contents">
<div class="dynheader">
Inheritance diagram for dlib::multiclass_svm_problem&lt; matrix_type, sample_type, label_type &gt;:</div>
<div class="dyncontent">
 <div class="center">
  <img src="classdlib_1_1multiclass__svm__problem.png" usemap="#dlib::multiclass_5Fsvm_5Fproblem_3C_20matrix_5Ftype_2C_20sample_5Ftype_2C_20label_5Ftype_20_3E_map" alt=""/>
  <map id="dlib::multiclass_5Fsvm_5Fproblem_3C_20matrix_5Ftype_2C_20sample_5Ftype_2C_20label_5Ftype_20_3E_map" name="dlib::multiclass_5Fsvm_5Fproblem_3C_20matrix_5Ftype_2C_20sample_5Ftype_2C_20label_5Ftype_20_3E_map">
<area href="classdlib_1_1structural__svm__problem__threaded.html" alt="dlib::structural_svm_problem_threaded&lt; matrix_type, std::vector&lt; std::pair&lt; unsigned long, matrix_type::type &gt; &gt; &gt;" shape="rect" coords="0,112,659,136"/>
<area href="classdlib_1_1structural__svm__problem.html" alt="dlib::structural_svm_problem&lt; matrix_type, std::vector&lt; std::pair&lt; unsigned long, matrix_type::type &gt; &gt; &gt;" shape="rect" coords="0,56,659,80"/>
<area href="classdlib_1_1oca__problem.html" alt="dlib::oca_problem&lt; matrix_type &gt;" shape="rect" coords="0,0,659,24"/>
  </map>
</div></div>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-types"></a>
Public Types</h2></td></tr>
<tr class="memitem:a5d4751a44496a949f5df50ed9767bf30"><td class="memItemLeft" align="right" valign="top">typedef matrix_type::type&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classdlib_1_1multiclass__svm__problem.html#a5d4751a44496a949f5df50ed9767bf30">scalar_type</a></td></tr>
<tr class="separator:a5d4751a44496a949f5df50ed9767bf30"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ab81c324fd643378b2c3a21258687434d"><td class="memItemLeft" align="right" valign="top"><a id="ab81c324fd643378b2c3a21258687434d"></a>
typedef std::vector&lt; std::pair&lt; unsigned long, <a class="el" href="classdlib_1_1multiclass__svm__problem.html#a5d4751a44496a949f5df50ed9767bf30">scalar_type</a> &gt; &gt;&#160;</td><td class="memItemRight" valign="bottom"><b>feature_vector_type</b></td></tr>
<tr class="separator:ab81c324fd643378b2c3a21258687434d"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="inherit_header pub_types_classdlib_1_1structural__svm__problem__threaded"><td colspan="2" onclick="javascript:toggleInherit('pub_types_classdlib_1_1structural__svm__problem__threaded')"><img src="closed.png" alt="-"/>&#160;Public Types inherited from <a class="el" href="classdlib_1_1structural__svm__problem__threaded.html">dlib::structural_svm_problem_threaded&lt; matrix_type, std::vector&lt; std::pair&lt; unsigned long, matrix_type::type &gt; &gt; &gt;</a></td></tr>
<tr class="memitem:a04bf53985203ee6a3efac4d3d8b76e72 inherit pub_types_classdlib_1_1structural__svm__problem__threaded"><td class="memItemLeft" align="right" valign="top"><a id="a04bf53985203ee6a3efac4d3d8b76e72"></a>
typedef <a class="el" href="classdlib_1_1structural__svm__problem.html#a838a31de24d3c3ea3f751c7db337b60f">matrix_type</a>&#160;</td><td class="memItemRight" valign="bottom"><b>matrix_type</b></td></tr>
<tr class="separator:a04bf53985203ee6a3efac4d3d8b76e72 inherit pub_types_classdlib_1_1structural__svm__problem__threaded"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a6b5483a292b416abc7f4889df06a484b inherit pub_types_classdlib_1_1structural__svm__problem__threaded"><td class="memItemLeft" align="right" valign="top"><a id="a6b5483a292b416abc7f4889df06a484b"></a>
typedef matrix_type::type&#160;</td><td class="memItemRight" valign="bottom"><b>scalar_type</b></td></tr>
<tr class="separator:a6b5483a292b416abc7f4889df06a484b inherit pub_types_classdlib_1_1structural__svm__problem__threaded"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:add7f306f0797ac554da6ab62f5c1b8f8 inherit pub_types_classdlib_1_1structural__svm__problem__threaded"><td class="memItemLeft" align="right" valign="top"><a id="add7f306f0797ac554da6ab62f5c1b8f8"></a>
typedef std::vector&lt; std::pair&lt; unsigned long, matrix_type::type &gt; &gt;&#160;</td><td class="memItemRight" valign="bottom"><b>feature_vector_type</b></td></tr>
<tr class="separator:add7f306f0797ac554da6ab62f5c1b8f8 inherit pub_types_classdlib_1_1structural__svm__problem__threaded"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="inherit_header pub_types_classdlib_1_1structural__svm__problem"><td colspan="2" onclick="javascript:toggleInherit('pub_types_classdlib_1_1structural__svm__problem')"><img src="closed.png" alt="-"/>&#160;Public Types inherited from <a class="el" href="classdlib_1_1structural__svm__problem.html">dlib::structural_svm_problem&lt; matrix_type, std::vector&lt; std::pair&lt; unsigned long, matrix_type::type &gt; &gt; &gt;</a></td></tr>
<tr class="memitem:a838a31de24d3c3ea3f751c7db337b60f inherit pub_types_classdlib_1_1structural__svm__problem"><td class="memItemLeft" align="right" valign="top">typedef <a class="el" href="classdlib_1_1structural__svm__problem.html#a838a31de24d3c3ea3f751c7db337b60f">matrix_type</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classdlib_1_1structural__svm__problem.html#a838a31de24d3c3ea3f751c7db337b60f">matrix_type</a></td></tr>
<tr class="separator:a838a31de24d3c3ea3f751c7db337b60f inherit pub_types_classdlib_1_1structural__svm__problem"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ad568aa6bb03f6292f334b6e41201f037 inherit pub_types_classdlib_1_1structural__svm__problem"><td class="memItemLeft" align="right" valign="top"><a id="ad568aa6bb03f6292f334b6e41201f037"></a>
typedef matrix_type::type&#160;</td><td class="memItemRight" valign="bottom"><b>scalar_type</b></td></tr>
<tr class="separator:ad568aa6bb03f6292f334b6e41201f037 inherit pub_types_classdlib_1_1structural__svm__problem"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:acb703e9adad7faf7987150a9940411f5 inherit pub_types_classdlib_1_1structural__svm__problem"><td class="memItemLeft" align="right" valign="top"><a id="acb703e9adad7faf7987150a9940411f5"></a>
typedef std::vector&lt; std::pair&lt; unsigned long, matrix_type::type &gt; &gt;&#160;</td><td class="memItemRight" valign="bottom"><b>feature_vector_type</b></td></tr>
<tr class="separator:acb703e9adad7faf7987150a9940411f5 inherit pub_types_classdlib_1_1structural__svm__problem"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="inherit_header pub_types_classdlib_1_1oca__problem"><td colspan="2" onclick="javascript:toggleInherit('pub_types_classdlib_1_1oca__problem')"><img src="closed.png" alt="-"/>&#160;Public Types inherited from <a class="el" href="classdlib_1_1oca__problem.html">dlib::oca_problem&lt; matrix_type &gt;</a></td></tr>
<tr class="memitem:a1349fc70c26000fa04e8329edae78902 inherit pub_types_classdlib_1_1oca__problem"><td class="memItemLeft" align="right" valign="top"><a id="a1349fc70c26000fa04e8329edae78902"></a>
typedef matrix_type::type&#160;</td><td class="memItemRight" valign="bottom"><b>scalar_type</b></td></tr>
<tr class="separator:a1349fc70c26000fa04e8329edae78902 inherit pub_types_classdlib_1_1oca__problem"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr class="memitem:a2758e0dc3900b9b5a990491b3c52727f"><td class="memItemLeft" align="right" valign="top"><a id="a2758e0dc3900b9b5a990491b3c52727f"></a>
&#160;</td><td class="memItemRight" valign="bottom"><b>multiclass_svm_problem</b> (const std::vector&lt; sample_type &gt; &amp;samples_, const std::vector&lt; label_type &gt; &amp;labels_, const std::vector&lt; label_type &gt; &amp;distinct_labels_, const unsigned long dims_, const unsigned long num_threads)</td></tr>
<tr class="separator:a2758e0dc3900b9b5a990491b3c52727f"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a45e72537798171e7a0914bd1e7c61341"><td class="memItemLeft" align="right" valign="top"><a id="a45e72537798171e7a0914bd1e7c61341"></a>
virtual long&#160;</td><td class="memItemRight" valign="bottom"><b>get_num_dimensions</b> () const</td></tr>
<tr class="separator:a45e72537798171e7a0914bd1e7c61341"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a1bd108a7d171d9ed256031a9d1a25f1b"><td class="memItemLeft" align="right" valign="top"><a id="a1bd108a7d171d9ed256031a9d1a25f1b"></a>
virtual long&#160;</td><td class="memItemRight" valign="bottom"><b>get_num_samples</b> () const</td></tr>
<tr class="separator:a1bd108a7d171d9ed256031a9d1a25f1b"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a6aade97617e7342c74440ec2db0c05f3"><td class="memItemLeft" align="right" valign="top"><a id="a6aade97617e7342c74440ec2db0c05f3"></a>
virtual void&#160;</td><td class="memItemRight" valign="bottom"><b>get_truth_joint_feature_vector</b> (long idx, feature_vector_type &amp;psi) const</td></tr>
<tr class="separator:a6aade97617e7342c74440ec2db0c05f3"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aa4c4503945fa8bb1b1e691b4b1e7fb29"><td class="memItemLeft" align="right" valign="top"><a id="aa4c4503945fa8bb1b1e691b4b1e7fb29"></a>
virtual void&#160;</td><td class="memItemRight" valign="bottom"><b>separation_oracle</b> (const long idx, const <a class="el" href="classdlib_1_1structural__svm__problem.html#a838a31de24d3c3ea3f751c7db337b60f">matrix_type</a> &amp;current_solution, <a class="el" href="classdlib_1_1multiclass__svm__problem.html#a5d4751a44496a949f5df50ed9767bf30">scalar_type</a> &amp;loss, feature_vector_type &amp;psi) const</td></tr>
<tr class="separator:aa4c4503945fa8bb1b1e691b4b1e7fb29"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="inherit_header pub_methods_classdlib_1_1structural__svm__problem__threaded"><td colspan="2" onclick="javascript:toggleInherit('pub_methods_classdlib_1_1structural__svm__problem__threaded')"><img src="closed.png" alt="-"/>&#160;Public Member Functions inherited from <a class="el" href="classdlib_1_1structural__svm__problem__threaded.html">dlib::structural_svm_problem_threaded&lt; matrix_type, std::vector&lt; std::pair&lt; unsigned long, matrix_type::type &gt; &gt; &gt;</a></td></tr>
<tr class="memitem:a347ede8e4d702c77979e2056ad1f01e1 inherit pub_methods_classdlib_1_1structural__svm__problem__threaded"><td class="memItemLeft" align="right" valign="top"><a id="a347ede8e4d702c77979e2056ad1f01e1"></a>
&#160;</td><td class="memItemRight" valign="bottom"><b>structural_svm_problem_threaded</b> (unsigned long num_threads)</td></tr>
<tr class="separator:a347ede8e4d702c77979e2056ad1f01e1 inherit pub_methods_classdlib_1_1structural__svm__problem__threaded"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a220b80687f913684f9c4bd8ee62848d2 inherit pub_methods_classdlib_1_1structural__svm__problem__threaded"><td class="memItemLeft" align="right" valign="top"><a id="a220b80687f913684f9c4bd8ee62848d2"></a>
unsigned long&#160;</td><td class="memItemRight" valign="bottom"><b>get_num_threads</b> () const</td></tr>
<tr class="separator:a220b80687f913684f9c4bd8ee62848d2 inherit pub_methods_classdlib_1_1structural__svm__problem__threaded"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="inherit_header pub_methods_classdlib_1_1structural__svm__problem"><td colspan="2" onclick="javascript:toggleInherit('pub_methods_classdlib_1_1structural__svm__problem')"><img src="closed.png" alt="-"/>&#160;Public Member Functions inherited from <a class="el" href="classdlib_1_1structural__svm__problem.html">dlib::structural_svm_problem&lt; matrix_type, std::vector&lt; std::pair&lt; unsigned long, matrix_type::type &gt; &gt; &gt;</a></td></tr>
<tr class="memitem:adf6211381551dcc1c317e726b9c193de inherit pub_methods_classdlib_1_1structural__svm__problem"><td class="memItemLeft" align="right" valign="top"><a id="adf6211381551dcc1c317e726b9c193de"></a>
scalar_type&#160;</td><td class="memItemRight" valign="bottom"><b>get_cache_based_epsilon</b> () const</td></tr>
<tr class="separator:adf6211381551dcc1c317e726b9c193de inherit pub_methods_classdlib_1_1structural__svm__problem"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a9f75fc47a1080ab072dcbfbc4d6b00a4 inherit pub_methods_classdlib_1_1structural__svm__problem"><td class="memItemLeft" align="right" valign="top"><a id="a9f75fc47a1080ab072dcbfbc4d6b00a4"></a>
void&#160;</td><td class="memItemRight" valign="bottom"><b>set_cache_based_epsilon</b> (scalar_type eps_)</td></tr>
<tr class="separator:a9f75fc47a1080ab072dcbfbc4d6b00a4 inherit pub_methods_classdlib_1_1structural__svm__problem"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a6f6201af37da8972ea255d54fd72ddcc inherit pub_methods_classdlib_1_1structural__svm__problem"><td class="memItemLeft" align="right" valign="top"><a id="a6f6201af37da8972ea255d54fd72ddcc"></a>
void&#160;</td><td class="memItemRight" valign="bottom"><b>set_epsilon</b> (scalar_type eps_)</td></tr>
<tr class="separator:a6f6201af37da8972ea255d54fd72ddcc inherit pub_methods_classdlib_1_1structural__svm__problem"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:af94f764df97c667d062ab4de727b65fc inherit pub_methods_classdlib_1_1structural__svm__problem"><td class="memItemLeft" align="right" valign="top"><a id="af94f764df97c667d062ab4de727b65fc"></a>
const scalar_type&#160;</td><td class="memItemRight" valign="bottom"><b>get_epsilon</b> () const</td></tr>
<tr class="separator:af94f764df97c667d062ab4de727b65fc inherit pub_methods_classdlib_1_1structural__svm__problem"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:abeb6312b799044b0ac069a3275212a1f inherit pub_methods_classdlib_1_1structural__svm__problem"><td class="memItemLeft" align="right" valign="top"><a id="abeb6312b799044b0ac069a3275212a1f"></a>
unsigned long&#160;</td><td class="memItemRight" valign="bottom"><b>get_max_iterations</b> () const</td></tr>
<tr class="separator:abeb6312b799044b0ac069a3275212a1f inherit pub_methods_classdlib_1_1structural__svm__problem"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a30904cb3211e8b0d949640d07190906e inherit pub_methods_classdlib_1_1structural__svm__problem"><td class="memItemLeft" align="right" valign="top"><a id="a30904cb3211e8b0d949640d07190906e"></a>
void&#160;</td><td class="memItemRight" valign="bottom"><b>set_max_iterations</b> (unsigned long max_iter)</td></tr>
<tr class="separator:a30904cb3211e8b0d949640d07190906e inherit pub_methods_classdlib_1_1structural__svm__problem"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a22f35f2fda4a495b3c96fa485184c343 inherit pub_methods_classdlib_1_1structural__svm__problem"><td class="memItemLeft" align="right" valign="top"><a id="a22f35f2fda4a495b3c96fa485184c343"></a>
void&#160;</td><td class="memItemRight" valign="bottom"><b>set_max_cache_size</b> (unsigned long max_size)</td></tr>
<tr class="separator:a22f35f2fda4a495b3c96fa485184c343 inherit pub_methods_classdlib_1_1structural__svm__problem"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:af33578f2ee7d08e8f3ca22417197db31 inherit pub_methods_classdlib_1_1structural__svm__problem"><td class="memItemLeft" align="right" valign="top"><a id="af33578f2ee7d08e8f3ca22417197db31"></a>
unsigned long&#160;</td><td class="memItemRight" valign="bottom"><b>get_max_cache_size</b> () const</td></tr>
<tr class="separator:af33578f2ee7d08e8f3ca22417197db31 inherit pub_methods_classdlib_1_1structural__svm__problem"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a3523f2952290c55dbc735eeea856dd72 inherit pub_methods_classdlib_1_1structural__svm__problem"><td class="memItemLeft" align="right" valign="top"><a id="a3523f2952290c55dbc735eeea856dd72"></a>
void&#160;</td><td class="memItemRight" valign="bottom"><b>be_verbose</b> ()</td></tr>
<tr class="separator:a3523f2952290c55dbc735eeea856dd72 inherit pub_methods_classdlib_1_1structural__svm__problem"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a228877d7935cbda8f87b2e61bd370b9d inherit pub_methods_classdlib_1_1structural__svm__problem"><td class="memItemLeft" align="right" valign="top"><a id="a228877d7935cbda8f87b2e61bd370b9d"></a>
void&#160;</td><td class="memItemRight" valign="bottom"><b>be_quiet</b> ()</td></tr>
<tr class="separator:a228877d7935cbda8f87b2e61bd370b9d inherit pub_methods_classdlib_1_1structural__svm__problem"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:adbd70c0de1acc5203473d9516ba38516 inherit pub_methods_classdlib_1_1structural__svm__problem"><td class="memItemLeft" align="right" valign="top"><a id="adbd70c0de1acc5203473d9516ba38516"></a>
scalar_type&#160;</td><td class="memItemRight" valign="bottom"><b>get_c</b> () const</td></tr>
<tr class="separator:adbd70c0de1acc5203473d9516ba38516 inherit pub_methods_classdlib_1_1structural__svm__problem"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a4ce4fb486177ef7cbd9517041e797e62 inherit pub_methods_classdlib_1_1structural__svm__problem"><td class="memItemLeft" align="right" valign="top"><a id="a4ce4fb486177ef7cbd9517041e797e62"></a>
void&#160;</td><td class="memItemRight" valign="bottom"><b>set_c</b> (scalar_type C_)</td></tr>
<tr class="separator:a4ce4fb486177ef7cbd9517041e797e62 inherit pub_methods_classdlib_1_1structural__svm__problem"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:acb399c2d9096a37939e1243591ce9b3e inherit pub_methods_classdlib_1_1structural__svm__problem"><td class="memItemLeft" align="right" valign="top"><a id="acb399c2d9096a37939e1243591ce9b3e"></a>
void&#160;</td><td class="memItemRight" valign="bottom"><b>add_nuclear_norm_regularizer</b> (long first_dimension, long rows, long cols, double regularization_strength)</td></tr>
<tr class="separator:acb399c2d9096a37939e1243591ce9b3e inherit pub_methods_classdlib_1_1structural__svm__problem"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:afa2a57bf3be12498303806340a6668b2 inherit pub_methods_classdlib_1_1structural__svm__problem"><td class="memItemLeft" align="right" valign="top"><a id="afa2a57bf3be12498303806340a6668b2"></a>
unsigned long&#160;</td><td class="memItemRight" valign="bottom"><b>num_nuclear_norm_regularizers</b> () const</td></tr>
<tr class="separator:afa2a57bf3be12498303806340a6668b2 inherit pub_methods_classdlib_1_1structural__svm__problem"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a62fac7b3c8704635590b61484ef12d2c inherit pub_methods_classdlib_1_1structural__svm__problem"><td class="memItemLeft" align="right" valign="top"><a id="a62fac7b3c8704635590b61484ef12d2c"></a>
void&#160;</td><td class="memItemRight" valign="bottom"><b>clear_nuclear_norm_regularizers</b> ()</td></tr>
<tr class="separator:a62fac7b3c8704635590b61484ef12d2c inherit pub_methods_classdlib_1_1structural__svm__problem"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ae3ca7c0fcaebed3cb0edcff4e9ab15c8 inherit pub_methods_classdlib_1_1structural__svm__problem"><td class="memItemLeft" align="right" valign="top"><a id="ae3ca7c0fcaebed3cb0edcff4e9ab15c8"></a>
virtual void&#160;</td><td class="memItemRight" valign="bottom"><b>get_truth_joint_feature_vector</b> (long idx, feature_vector_type &amp;psi) const=0</td></tr>
<tr class="separator:ae3ca7c0fcaebed3cb0edcff4e9ab15c8 inherit pub_methods_classdlib_1_1structural__svm__problem"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a95e2c042ca281db5a2b246eb6a7b1733 inherit pub_methods_classdlib_1_1structural__svm__problem"><td class="memItemLeft" align="right" valign="top"><a id="a95e2c042ca281db5a2b246eb6a7b1733"></a>
virtual void&#160;</td><td class="memItemRight" valign="bottom"><b>separation_oracle</b> (const long idx, const <a class="el" href="classdlib_1_1structural__svm__problem.html#a838a31de24d3c3ea3f751c7db337b60f">matrix_type</a> &amp;current_solution, scalar_type &amp;loss, feature_vector_type &amp;psi) const=0</td></tr>
<tr class="separator:a95e2c042ca281db5a2b246eb6a7b1733 inherit pub_methods_classdlib_1_1structural__svm__problem"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pri-methods"></a>
Private Member Functions</h2></td></tr>
<tr class="memitem:a5b1b24026b30e3ee634d802baa581731"><td class="memItemLeft" align="right" valign="top"><a id="a5b1b24026b30e3ee634d802baa581731"></a>
void&#160;</td><td class="memItemRight" valign="bottom"><b>offset_feature_vector</b> (feature_vector_type &amp;sample, const unsigned long val) const</td></tr>
<tr class="separator:a5b1b24026b30e3ee634d802baa581731"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pri-attribs"></a>
Private Attributes</h2></td></tr>
<tr class="memitem:a2ec3979e57cc8507076bc42f78a4b183"><td class="memItemLeft" align="right" valign="top"><a id="a2ec3979e57cc8507076bc42f78a4b183"></a>
const std::vector&lt; sample_type &gt; &amp;&#160;</td><td class="memItemRight" valign="bottom"><b>samples</b></td></tr>
<tr class="separator:a2ec3979e57cc8507076bc42f78a4b183"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a2b8956ccb7f4bd17985691ea7cb3804f"><td class="memItemLeft" align="right" valign="top"><a id="a2b8956ccb7f4bd17985691ea7cb3804f"></a>
const std::vector&lt; label_type &gt; &amp;&#160;</td><td class="memItemRight" valign="bottom"><b>labels</b></td></tr>
<tr class="separator:a2b8956ccb7f4bd17985691ea7cb3804f"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a37aef9a3d6c6ba1ab0c248ddc2a5f8d5"><td class="memItemLeft" align="right" valign="top"><a id="a37aef9a3d6c6ba1ab0c248ddc2a5f8d5"></a>
const std::vector&lt; label_type &gt; &amp;&#160;</td><td class="memItemRight" valign="bottom"><b>distinct_labels</b></td></tr>
<tr class="separator:a37aef9a3d6c6ba1ab0c248ddc2a5f8d5"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a676b3937ce044146cb81426b21794f2d"><td class="memItemLeft" align="right" valign="top"><a id="a676b3937ce044146cb81426b21794f2d"></a>
const long&#160;</td><td class="memItemRight" valign="bottom"><b>dims</b></td></tr>
<tr class="separator:a676b3937ce044146cb81426b21794f2d"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="inherited"></a>
Additional Inherited Members</h2></td></tr>
<tr class="inherit_header pro_methods_classdlib_1_1structural__svm__problem"><td colspan="2" onclick="javascript:toggleInherit('pro_methods_classdlib_1_1structural__svm__problem')"><img src="closed.png" alt="-"/>&#160;Protected Member Functions inherited from <a class="el" href="classdlib_1_1structural__svm__problem.html">dlib::structural_svm_problem&lt; matrix_type, std::vector&lt; std::pair&lt; unsigned long, matrix_type::type &gt; &gt; &gt;</a></td></tr>
<tr class="memitem:a1faeda0e0132462aaa230288cbb88d52 inherit pro_methods_classdlib_1_1structural__svm__problem"><td class="memItemLeft" align="right" valign="top"><a id="a1faeda0e0132462aaa230288cbb88d52"></a>
void&#160;</td><td class="memItemRight" valign="bottom"><b>compute_nuclear_norm_parts</b> (const <a class="el" href="classdlib_1_1structural__svm__problem.html#a838a31de24d3c3ea3f751c7db337b60f">matrix_type</a> &amp;m, <a class="el" href="classdlib_1_1structural__svm__problem.html#a838a31de24d3c3ea3f751c7db337b60f">matrix_type</a> &amp;grad, scalar_type &amp;obj) const</td></tr>
<tr class="separator:a1faeda0e0132462aaa230288cbb88d52 inherit pro_methods_classdlib_1_1structural__svm__problem"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a6001eb14630a26a0c7382ccfe679b96c inherit pro_methods_classdlib_1_1structural__svm__problem"><td class="memItemLeft" align="right" valign="top"><a id="a6001eb14630a26a0c7382ccfe679b96c"></a>
void&#160;</td><td class="memItemRight" valign="bottom"><b>separation_oracle_cached</b> (const long idx, const <a class="el" href="classdlib_1_1structural__svm__problem.html#a838a31de24d3c3ea3f751c7db337b60f">matrix_type</a> &amp;current_solution, scalar_type &amp;loss, feature_vector_type &amp;psi) const</td></tr>
<tr class="separator:a6001eb14630a26a0c7382ccfe679b96c inherit pro_methods_classdlib_1_1structural__svm__problem"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="inherit_header pro_attribs_classdlib_1_1structural__svm__problem"><td colspan="2" onclick="javascript:toggleInherit('pro_attribs_classdlib_1_1structural__svm__problem')"><img src="closed.png" alt="-"/>&#160;Protected Attributes inherited from <a class="el" href="classdlib_1_1structural__svm__problem.html">dlib::structural_svm_problem&lt; matrix_type, std::vector&lt; std::pair&lt; unsigned long, matrix_type::type &gt; &gt; &gt;</a></td></tr>
<tr class="memitem:afbc4b6143e9697a1ddd37db3ac391d8b inherit pro_attribs_classdlib_1_1structural__svm__problem"><td class="memItemLeft" align="right" valign="top"><a id="afbc4b6143e9697a1ddd37db3ac391d8b"></a>
std::vector&lt; <a class="el" href="structdlib_1_1impl_1_1nuclear__norm__regularizer.html">impl::nuclear_norm_regularizer</a> &gt;&#160;</td><td class="memItemRight" valign="bottom"><b>nuclear_norm_regularizers</b></td></tr>
<tr class="separator:afbc4b6143e9697a1ddd37db3ac391d8b inherit pro_attribs_classdlib_1_1structural__svm__problem"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a08a69ca9ec5e61b5640971601b85e0a7 inherit pro_attribs_classdlib_1_1structural__svm__problem"><td class="memItemLeft" align="right" valign="top"><a id="a08a69ca9ec5e61b5640971601b85e0a7"></a>
scalar_type&#160;</td><td class="memItemRight" valign="bottom"><b>saved_current_risk_gap</b></td></tr>
<tr class="separator:a08a69ca9ec5e61b5640971601b85e0a7 inherit pro_attribs_classdlib_1_1structural__svm__problem"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a7f18bec5509dc91ac866face713989ec inherit pro_attribs_classdlib_1_1structural__svm__problem"><td class="memItemLeft" align="right" valign="top"><a id="a7f18bec5509dc91ac866face713989ec"></a>
<a class="el" href="classdlib_1_1structural__svm__problem.html#a838a31de24d3c3ea3f751c7db337b60f">matrix_type</a>&#160;</td><td class="memItemRight" valign="bottom"><b>psi_true</b></td></tr>
<tr class="separator:a7f18bec5509dc91ac866face713989ec inherit pro_attribs_classdlib_1_1structural__svm__problem"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aa3912570168deff1227f88dedc82575c inherit pro_attribs_classdlib_1_1structural__svm__problem"><td class="memItemLeft" align="right" valign="top"><a id="aa3912570168deff1227f88dedc82575c"></a>
scalar_type&#160;</td><td class="memItemRight" valign="bottom"><b>eps</b></td></tr>
<tr class="separator:aa3912570168deff1227f88dedc82575c inherit pro_attribs_classdlib_1_1structural__svm__problem"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a32c1ef15d68ae71e97081c86015c4a00 inherit pro_attribs_classdlib_1_1structural__svm__problem"><td class="memItemLeft" align="right" valign="top"><a id="a32c1ef15d68ae71e97081c86015c4a00"></a>
unsigned long&#160;</td><td class="memItemRight" valign="bottom"><b>max_iterations</b></td></tr>
<tr class="separator:a32c1ef15d68ae71e97081c86015c4a00 inherit pro_attribs_classdlib_1_1structural__svm__problem"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aa63b2b0165646540d4375e0fa95c2364 inherit pro_attribs_classdlib_1_1structural__svm__problem"><td class="memItemLeft" align="right" valign="top"><a id="aa63b2b0165646540d4375e0fa95c2364"></a>
bool&#160;</td><td class="memItemRight" valign="bottom"><b>verbose</b></td></tr>
<tr class="separator:aa63b2b0165646540d4375e0fa95c2364 inherit pro_attribs_classdlib_1_1structural__svm__problem"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a3a55a97dc58c586d1fe7e6d9ba06019c inherit pro_attribs_classdlib_1_1structural__svm__problem"><td class="memItemLeft" align="right" valign="top"><a id="a3a55a97dc58c586d1fe7e6d9ba06019c"></a>
std::vector&lt; <a class="el" href="classdlib_1_1cache__element__structural__svm.html">cache_element_structural_svm</a>&lt; <a class="el" href="classdlib_1_1structural__svm__problem.html">structural_svm_problem</a> &gt; &gt;&#160;</td><td class="memItemRight" valign="bottom"><b>cache</b></td></tr>
<tr class="separator:a3a55a97dc58c586d1fe7e6d9ba06019c inherit pro_attribs_classdlib_1_1structural__svm__problem"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a4d7ff04fbbc4b3a737b3a26726f9318f inherit pro_attribs_classdlib_1_1structural__svm__problem"><td class="memItemLeft" align="right" valign="top"><a id="a4d7ff04fbbc4b3a737b3a26726f9318f"></a>
bool&#160;</td><td class="memItemRight" valign="bottom"><b>skip_cache</b></td></tr>
<tr class="separator:a4d7ff04fbbc4b3a737b3a26726f9318f inherit pro_attribs_classdlib_1_1structural__svm__problem"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a78ceaeb40375a9ef47b7444865981224 inherit pro_attribs_classdlib_1_1structural__svm__problem"><td class="memItemLeft" align="right" valign="top"><a id="a78ceaeb40375a9ef47b7444865981224"></a>
int&#160;</td><td class="memItemRight" valign="bottom"><b>count_below_eps</b></td></tr>
<tr class="separator:a78ceaeb40375a9ef47b7444865981224 inherit pro_attribs_classdlib_1_1structural__svm__problem"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a23b200151db4f019a376f3b83668cc0f inherit pro_attribs_classdlib_1_1structural__svm__problem"><td class="memItemLeft" align="right" valign="top"><a id="a23b200151db4f019a376f3b83668cc0f"></a>
unsigned long&#160;</td><td class="memItemRight" valign="bottom"><b>max_cache_size</b></td></tr>
<tr class="separator:a23b200151db4f019a376f3b83668cc0f inherit pro_attribs_classdlib_1_1structural__svm__problem"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a021b4fe20f91115ef8a6e2a14e360251 inherit pro_attribs_classdlib_1_1structural__svm__problem"><td class="memItemLeft" align="right" valign="top"><a id="a021b4fe20f91115ef8a6e2a14e360251"></a>
bool&#160;</td><td class="memItemRight" valign="bottom"><b>converged</b></td></tr>
<tr class="separator:a021b4fe20f91115ef8a6e2a14e360251 inherit pro_attribs_classdlib_1_1structural__svm__problem"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ab564b7b1d08c7d43bc2653ea7faa93a8 inherit pro_attribs_classdlib_1_1structural__svm__problem"><td class="memItemLeft" align="right" valign="top"><a id="ab564b7b1d08c7d43bc2653ea7faa93a8"></a>
double&#160;</td><td class="memItemRight" valign="bottom"><b>nuclear_norm_part</b></td></tr>
<tr class="separator:ab564b7b1d08c7d43bc2653ea7faa93a8 inherit pro_attribs_classdlib_1_1structural__svm__problem"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:abff8d3d10e6af68a3e0b6cd9f960cb87 inherit pro_attribs_classdlib_1_1structural__svm__problem"><td class="memItemLeft" align="right" valign="top"><a id="abff8d3d10e6af68a3e0b6cd9f960cb87"></a>
scalar_type&#160;</td><td class="memItemRight" valign="bottom"><b>cache_based_eps</b></td></tr>
<tr class="separator:abff8d3d10e6af68a3e0b6cd9f960cb87 inherit pro_attribs_classdlib_1_1structural__svm__problem"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a552c537e2ba88270ddcea3a397b8b71c inherit pro_attribs_classdlib_1_1structural__svm__problem"><td class="memItemLeft" align="right" valign="top"><a id="a552c537e2ba88270ddcea3a397b8b71c"></a>
scalar_type&#160;</td><td class="memItemRight" valign="bottom"><b>C</b></td></tr>
<tr class="separator:a552c537e2ba88270ddcea3a397b8b71c inherit pro_attribs_classdlib_1_1structural__svm__problem"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<h2 class="groupheader">Member Typedef Documentation</h2>
<a id="a5d4751a44496a949f5df50ed9767bf30"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a5d4751a44496a949f5df50ed9767bf30">&#9670;&nbsp;</a></span>scalar_type</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename matrix_type, typename sample_type, typename label_type&gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">typedef matrix_type::type <a class="el" href="classdlib_1_1multiclass__svm__problem.html">dlib::multiclass_svm_problem</a>&lt; <a class="el" href="classdlib_1_1structural__svm__problem.html#a838a31de24d3c3ea3f751c7db337b60f">matrix_type</a>, sample_type, label_type &gt;::scalar_type</td>
        </tr>
      </table>
</div><div class="memdoc">
<pre class="fragment">WHAT THIS OBJECT REPRESENTS
    This object defines the optimization problem for the multiclass SVM trainer
    object at the bottom of this file.  

    The joint feature vectors used by this object, the PSI(x,y) vectors, are
    defined as follows:
        PSI(x,0) = [x,0,0,0,0, ...,0]
        PSI(x,1) = [0,x,0,0,0, ...,0]
        PSI(x,2) = [0,0,x,0,0, ...,0]
    That is, if there are N labels then the joint feature vector has a
    dimension that is N times the dimension of a single x sample.  Also,
    note that we append a -1 value onto each x to account for the bias term.
</pre><p> ! </p>

</div>
</div>
<hr/>The documentation for this class was generated from the following file:<ul>
<li><a class="el" href="svm__multiclass__linear__trainer_8h_source.html">svm_multiclass_linear_trainer.h</a></li>
</ul>
</div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.16
</small></address>
</body>
</html>
